/*  Header file for opt_funcs.c                             */

/*  ML_genedata, a program for maximum likelihood modelling of gene family presence/absence data
 *  Copyright (C) 2007 by Matthew Spencer
 *
 *  This program is free software; you may redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the Free
 *  Software Foundation; either version 2 of the License, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *  For any other enquiries write to Matthew Spencer, School of Biological Sciences,
 *  University of Liverpool, Crown Street, Liverpool, L69 7ZB, UK.
 *
 *  Or send E-mail to m.spencer@liverpool.ac.uk
 * 
 *---------------------------------------------------------------------------
 Parts of this program (functions to read phylip file) are based on fastDNAml by Gary J. Olsen, which is in turn based
 *  partly on dnaml by Joseph Felsenstein
 *
 *  Copyright notice from dnaml:
 *
 *     version 3.3. (c) Copyright 1986, 1990 by the University of Washington
 *     and Joseph Felsenstein.  Written by Joseph Felsenstein.  Permission is
 *     granted to copy and use this program provided no fee is charged for it
 *     and provided that this copyright notice is not removed.
 *
------------------------------------------------------------------------------
 *
 * Parts of this program (functions to read tree file and data structures for trees) are based on Seq-Gen by Andrew Rambaut and Nick Grassly * Copyright notice for Seq-Gen:
 *  
   Sequence Generator - seq-gen, version 1.3.2
   Copyright (c)1996-2004, Andrew Rambaut & Nick Grassly
   Department of Zoology, University of Oxford			
   All rights reserved.                          

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:

     1. Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.

     2. Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution.

     3. The names of its contributors may not be used to endorse or promote 
        products derived from this software without specific prior written 
        permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


   Any feedback is very welcome.
   http://evolve.zoo.ox.ac.uk/software/Seq-Gen/
   email: andrew.rambaut@zoo.ox.ac.uk
*/

#include "ML_genedata.h"

void opt_edgeset(TTree *tree, TNode *node, int ncat, int ngenes, int nstates, double ***Qset, double **Pleft, double **Pright, double ***Panc, double **rootset, genomedata *gd, double *rho, double *rmult, double *edgescale);/*optimize all edge lengths*/

void edge_opt(TTree *tree, TNode *node, double treeloglike, int ncat, int ngenes, int nstates, double ***Qset, double **Pleft, double **Pright, double ***Panc, double *rho, double *rmult, double *edgescale, genomedata *gd, double **rootset, int LRind);/*optimize a single edge length*/

double tree_opt(TTree *tree, int ncat,int nmajor, int gammacat, int ngenes, int nstates, double ***Qset, double **Pleft, double **Pright, double ***Panc, double **rootp, double **rootset, genomedata *gd, double *rhop, double *rho, double *rmult, double *edgescale, double *alpha, double **piset,parameters *params,int maxQ);/*optimize parameters other than edge lengths*/

void gradHessprint(TTree *tree,int ncat, int nmajor, int gammacat, int ngenes, int nstates, double ***Qset, double **Pleft, double **Pright, double ***Panc, double **rootp, double **rootset, genomedata *gd, double *rhop, double *rho, double *rmult, double *edgescale, double *alpha, double **piset,parameters *params,int maxQ, FILE *out_fv, double treeloglike);/*print gradient and Hessian for parameters other than edge lengths*/

